package com.loafle.overflow.model.email;

import com.loafle.overflow.model.member.Member;
import com.loafle.overflow.model.meta.MetaEmailStatus;

import javax.persistence.*;
import java.util.Date;

/**
 * Created by root on 17. 6. 22.
 */
@Entity
@Table(name = "EMAIL_AUTH", schema = "public")
public class EmailAuth {
  private Long id;
  private String emailAuthKey;
  private Date createDate;
  private Date authConfirmDate;
  private Member member;
  private MetaEmailStatus metaEmailStatus;

  @Id
  @GeneratedValue(strategy = GenerationType.IDENTITY)
  public Long getId() {
    return id;
  }

  public void setId(Long id) {
    this.id = id;
  }

  @Basic
  @Column(name = "EMAIL_AUTH_KEY", nullable = true, length = 50)
  public String getEmailAuthKey() {
    return emailAuthKey;
  }

  public void setEmailAuthKey(String emailAuthKey) {
    this.emailAuthKey = emailAuthKey;
  }

  @Basic
  @Column(name = "CREATE_DATE", nullable = false, columnDefinition = "TIMESTAMP DEFAULT CURRENT_TIMESTAMP", insertable = false, updatable = false)
  public Date getCreateDate() {
    return createDate;
  }

  public void setCreateDate(Date createDate) {
    this.createDate = createDate;
  }

  @Basic
  @Column(name = "AUTH_CONFIRM_DATE", nullable = true, insertable = true, updatable = true)
  public Date getAuthConfirmDate() {
    return authConfirmDate;
  }

  public void setAuthConfirmDate(Date authConfirmDate) {
    this.authConfirmDate = authConfirmDate;
  }

  @ManyToOne
  @JoinColumn(name = "MEMBER_ID", nullable = false)
  public Member getMember() {
    return member;
  }

  public void setMember(Member member) {
    this.member = member;
  }

  @ManyToOne
  @JoinColumn(name = "META_EMAIL_STATUS_ID", nullable = false)
  public MetaEmailStatus getMetaEmailStatus() {
    return metaEmailStatus;
  }

  public void setMetaEmailStatus(MetaEmailStatus metaEmailStatus) {
    this.metaEmailStatus = metaEmailStatus;
  }
}
