package com.loafle.overflow.service.central.target;

import java.util.List;

import com.loafle.overflow.core.annotation.WebappAPI;
import com.loafle.overflow.core.exception.OverflowException;
import com.loafle.overflow.model.discovery.Host;
import com.loafle.overflow.model.discovery.Service;
import com.loafle.overflow.model.probe.Probe;
import com.loafle.overflow.model.target.Target;

/**
 * Created by insanity on 17. 6. 28.
 */
public interface TargetService {

  public Target regist(Target target, Probe probe) throws OverflowException;

  public void remove(Target target, Probe probe) throws OverflowException;

  public Target read(String id) throws OverflowException;

  public Target increaseSensorCount(Target target) throws OverflowException;

  public Target decreaseSensorCount(Target target) throws OverflowException;

  @WebappAPI
  public Target modify(Target target) throws OverflowException;

  @WebappAPI
  void remove(Target target) throws OverflowException;

  @WebappAPI
  public List<Target> registDiscoveredTargets(Long probeId, List<Host> hosts, List<Service> services)
      throws OverflowException;

  @WebappAPI
  public Target readExistHostTarget(Long probeId, String ip) throws OverflowException;

  @WebappAPI
  public Target readExistServiceTarget(Long hostId, int portNumber, String portType) throws OverflowException;

}
